package sun.java2d.loops;

import java.awt.geom.AffineTransform;
import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.SurfaceData;

public class TransformHelper extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    private static RenderCache helpercache;
    
    public static TransformHelper locate(SurfaceType surfaceType) {
        return (TransformHelper)GraphicsPrimitiveMgr.locate(TransformHelper.primTypeID, surfaceType, CompositeType.SrcNoEa, SurfaceType.IntArgbPre);
    }
    
    public static synchronized TransformHelper getFromCache(SurfaceType surfaceType) {
        Object value = TransformHelper.helpercache.get(surfaceType, null, null);
        if (value != null) {
            return (TransformHelper)value;
        }
        TransformHelper locate = locate(surfaceType);
        if (locate == null) {
            return locate;
        }
        TransformHelper.helpercache.put(surfaceType, null, null, locate);
        return locate;
    }
    
    protected TransformHelper(SurfaceType surfaceType) {
        super(TransformHelper.methodSignature, TransformHelper.primTypeID, surfaceType, CompositeType.SrcNoEa, SurfaceType.IntArgbPre);
    }
    
    public TransformHelper(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, TransformHelper.methodSignature, TransformHelper.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public native void Transform(MaskBlit p0, SurfaceData p1, SurfaceData p2, Composite p3, Region p4, AffineTransform p5, int p6, int p7, int p8, int p9, int p10, int p11, int p12, int p13, int p14, int[] p15, int p16, int p17);
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return null;
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new TransformHelper.TraceTransformHelper(this);
    }
    
    static {
        methodSignature = "TransformHelper(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
        TransformHelper.helpercache = new RenderCache(10);
    }
    
    private static class TraceTransformHelper extends TransformHelper
    {
        TransformHelper target;
        
        public TraceTransformHelper(TransformHelper target) {
            super(target.getSourceType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void Transform(MaskBlit maskBlit, SurfaceData surfaceData, SurfaceData surfaceData2, Composite composite, Region region, AffineTransform affineTransform, int n, int n2, int n3, int n4, int n5, int n6, int n7, int n8, int n9, int[] array, int n10, int n11) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.Transform(maskBlit, surfaceData, surfaceData2, composite, region, affineTransform, n, n2, n3, n4, n5, n6, n7, n8, n9, array, n10, n11);
        }
    }
}
